        PAGE    255,132
;TESTDLL:    a dll to test linkage conventions
        EXTRN   DosBeep:FAR
        EXTRN   DosChgFilePtr:FAR
        EXTRN   DosClose:FAR
        EXTRN   DosGetInfoSeg:FAR
        EXTRN   DosOpen:FAR
        EXTRN   DosSleep:FAR
        EXTRN   DosWrite:FAR
        PUBLIC  DUMPADR
        PUBLIC  DUMPALL
        PUBLIC  DUMPPTR
        PUBLIC  DUMPRET
        PUBLIC  DUMPWHP
        PUBLIC  DUMPWRD
        .386P   
        .XALL
AUDIO   =       1
PUSHM   MACRO   PP
        IRP     X,<PP>
        push    X
        ENDM
        ENDM
POPM    MACRO   PP
        IRP     X,<PP>
        pop     X
        ENDM
        ENDM
OS2CALL MACRO   RTN,AA
        pushm   <AA>
        call    RTN
        ENDM
PMGSAVE MACRO   RGS
        push    bp
        mov     bp,sp
        pushm   <ds,es,di,si>
        IFNB    <RGS>
        pushm   <RGS>
        ENDIF
        ENDM
PMGEXIT MACRO   SGR,PV
        IFNB    <SGR>
        popm    <SGR>
        ENDIF
        popm    <si,di,es,ds,bp>
        assume  ds:NOTHING,es:NOTHING
        ret     PV
        ENDM

MYDATA  segment para public use16 'DATA'
rc      dw      ?,?
fhand   dw      ?
fname   db      '00000000.STK',0
from    db      'TestDLL@',0
addr    db      ', parm@',0
wurd    db      ', word=',0
stak    db      ', stack:',0
crlf    db      13,10,0
outbuf  db      72 dup(?)
MYDATA  ends
;
 
MYTEXT  segment para public use16 'CODE'
        assume  cs:MYTEXT
;
; * * * internal routines * * * ASSUME ES is segment MYDATA * * *
;
nibout  proc    near
        and     al,0fh
        add     al,90h 
        daa             
        adc     al,40h
        daa        
        mov     es:[di],al
        inc     di
        ret
nibout  endp
;
bytout  proc    near
        mov     al,[si]
        shr     al,4
        call    nibout
        mov     al,[si]
        call    nibout
        dec     si
        ret
bytout  endp
;
blkwrd  proc    near
        mov     byte ptr es:[di],' '
        inc     di
wrdout  proc    near
        call    bytout
        call    bytout
        ret
wrdout  endp
blkwrd  endp
;
blkadr  proc    near
        call    blkwrd
        mov     byte ptr es:[di],':'
        inc     di
        call    wrdout
        ret
blkadr  endp
;
mbuf    proc    near
        jmp     short mbufl
mbufs:  mov     es:[di],al
        inc     di
mbufl:  mov     al,es:[si]
        inc     si
        or      al,al
        jnz     mbufs
mbufx:  ret
mbuf    endp
;
init    proc    near
        mov     ax,seg MYDATA
        mov     es,ax
        pushm   <es,<offset fname>,es,<offset fhand>,es,<offset rc>>
        os2call DosOpen,<0,0,0,17,5191h,0,0>
        os2call DosChgFilePtr,<<es:fhand>,0,0,2,es,<offset rc>>
        mov     di,offset outbuf
        mov     si,offset from
        call    mbuf
        mov     ax,ss
        mov     ds,ax
        lea     si,[bp+5]
        call    blkadr
        ret
init    endp
;
stdexit proc    near
        mov     si,offset crlf
        call    mbuf
        sub     di,offset outbuf
        os2call DosWrite,<<es:fhand>,es,<offset outbuf>,di,es,<offset rc>>
        os2call DosClose,<<es:fhand>>
        ret
stdexit endp
;
IF     AUDIO
dbs     proc    near
        and     cx,15
        inc     cx
        os2call DosSleep,<0,125>
dbsl:   os2call DosBeep,<1760,35>
        os2call DosSleep,<0,35>
        loop    dbsl
        os2call DosSleep,<0,125>
        ret
dbs     endp
ENDIF
;
DUMPINI proc    far ;DLL initialization entry point.
        pmgsave
IF      AUDIO
        push    cx
        mov     cx,3                    ;audio indication
        call    dbs                     ;of initialization
        pop     cx
ENDIF
        mov     ax,seg MYDATA
        mov     es,ax
        assume  es:MYDATA
        os2call DosGetInfoSeg,<es,<offset rc+2>,es,<offset rc>>
        mov     ds,rc
        mov     si,1
        mov     di,offset fname
        call    wrdout
        mov     si,7
        call    wrdout
        mov     ax,1                    ;indicate success
        pmgexit
DUMPINI endp
;
DUMPWHP proc    far ;make a distinctive sound
        pushm   <bx,cx>
        mov     bx,150
        mov     cx,12
whpl:   os2call DosBeep,<bx,25>
        add     bx,250
        loop    whpl
        popm    <cx,bx>
        ret
DUMPWHP endp
;
DUMPRET proc    far ;dump the return address from the stack
        pmgsave
        call    init
        assume  es:MYDATA
        call    stdexit
        pmgexit
DUMPRET endp
;
DUMPWRD proc    far ;dump the first word on the stack
        pmgsave
        call    init
        assume  es:MYDATA
        mov     si,offset wurd
        call    mbuf
        lea     si,[bp+7]
        call    wrdout
        call    stdexit
        pmgexit ,2
DUMPWRD endp
;
DUMPADR proc    far ;dump one address from the stack
        pmgsave
        call    init
        assume  es:MYDATA
        mov     si,offset addr
        call    mbuf
        lea     si,[bp+9]
        call    blkadr
        call    stdexit
        pmgexit ,4
DUMPADR endp
;
DUMPALL proc    far ;dump 'n' words from the stack, following 'n' 
        pmgsave cx
        call    init
        assume  es:MYDATA
        mov     cx,[bp+6]
        and     cx,15
        inc     cx
        mov     si,offset stak
        call    mbuf
        lea     si,[bp+7]
allp:   call    blkwrd
        add     si,4
        loop    allp  
        call    stdexit
        pmgexit cx
DUMPALL endp
;
DUMPPTR proc    far ;dump four addresses from the stack
        pmgsave cx
        call    init
        assume  es:MYDATA
        mov     si,offset addr
        call    mbuf
        mov     cx,4
        lea     si,[bp+9]
ptrl:   call    blkadr
        add     si,8
        loop    ptrl
        call    stdexit
        pmgexit cx,16
DUMPPTR endp
;
MYTEXT  ends
        end     DUMPINI
