	TITLE	GOOSE.C
	.386
	.387
	INCLUDELIB OS2386.LIB
	INCLUDELIB dde4sbs.lib
CODE32	SEGMENT PARA USE32 PUBLIC 'CODE'
CODE32	ENDS
DATA32	SEGMENT PARA USE32 PUBLIC 'DATA'
DATA32	ENDS
CONST32	SEGMENT PARA USE32 PUBLIC 'CONST'
CONST32	ENDS
BSS32	SEGMENT PARA USE32 PUBLIC 'BSS'
BSS32	ENDS
CONST	SEGMENT DWORD USE32 PUBLIC 'DATA'
CONST	ENDS
DGROUP	GROUP CONST32, BSS32, DATA32
	ASSUME	CS:FLAT, DS:FLAT, SS:FLAT, ES:FLAT
	PUBLIC	pname
	PUBLIC	qname
	PUBLIC	sname
	EXTRN	DosAllocThreadLocalMemory:PROC
	EXTRN	_printfieee:PROC
	EXTRN	DosSleep:PROC
	EXTRN	setbuf:PROC
	EXTRN	DosGetInfoBlocks:PROC
	EXTRN	DosCreateThread:PROC
	EXTRN	gbl:PROC
	EXTRN	ins:PROC
	EXTRN	DosCreateQueue:PROC
	EXTRN	DosOpenQueue:PROC
	EXTRN	DosCreateNPipe:PROC
	EXTRN	DosCreateEventSem:PROC
	EXTRN	DosSetNPipeSem:PROC
	EXTRN	fgets:PROC
	EXTRN	strnicmp:PROC
	EXTRN	DosConnectNPipe:PROC
	EXTRN	DosRead:PROC
	EXTRN	DosOpen:PROC
	EXTRN	DosReadQueue:PROC
	EXTRN	strcpy:PROC
	EXTRN	DosClose:PROC
	EXTRN	DosCloseQueue:PROC
	EXTRN	DosKillThread:PROC
	EXTRN	_DosFlatToSel:PROC
	EXTRN	_DosSelToFlat:PROC
	EXTRN	stdout:DWORD
	EXTRN	stdin:DWORD
	EXTRN	_exeentry:PROC
CONST	SEGMENT
pname	DB "\PIPE\GOOSE\MESSAGES",0H
	ALIGN 04H
qname	DB "\QUEUES\GOOSE\FIFO.QUE",0H
	ALIGN 04H
sname	DB "\SEM32\GOOSE\PIPE",0H
CONST	ENDS
DATA32	SEGMENT
@STAT1	DB "thread %d local memory a"
DB "t %p",0aH,0H
	ALIGN 04H
@STAT2	DB "thread %u sleeping",0aH,0H
@STAT3	DB "thread 1 local memory at"
DB " %p",0aH,0H
	ALIGN 04H
@STAT4	DB "dll global data is locat"
DB "ed at %p",0aH,0H
	ALIGN 04H
@STAT5	DB "dll instance data is loc"
DB "ated at %p",0aH,0H
@STAT6	DB "rc from create queue was"
DB " %d",0aH,0H
	ALIGN 04H
@STAT7	DB "create queue handle is %"
DB "x, open queue handle is "
DB "%x",0aH,0H
@STAT8	DB "rq will read from the qu"
DB "eue",0aH,0H
	ALIGN 04H
@STAT9	DB "queue already exists",0aH,0H
	ALIGN 04H
@STATa	DB "rc from open queue was %"
DB "d",0aH,0H
	ALIGN 04H
@STATb	DB "unable to create named p"
DB "ipe, rc=%d",0aH,0H
@STATc	DB "pipe created, handle=%x",0aH
DB 0H
	ALIGN 04H
@STATd	DB "unable to create event s"
DB "em for pipe, rc=%d",0aH,0H
@STATe	DB "pipe sem created",0aH,0H
	ALIGN 04H
@STATf	DB "unable to set pipe sem, "
DB "rc=%d",0aH,0H
	ALIGN 04H
@STAT10	DB "pipe sem set",0aH,0H
	ALIGN 04H
@STAT11	DB "rp will read from the pi"
DB "pe",0aH,0H
@STAT12	DB "g? and i? will print the"
DB " global or instance data"
DB 0aH,0H
	ALIGN 04H
@STAT13	DB "g= and i= will copy into"
DB " global or instance data"
DB 0aH,0H
	ALIGN 04H
@STAT14	DB "use q, Q, or break to en"
DB "d program",0aH,0H
@STAT15	DB "rp",0H
	ALIGN 04H
@STAT16	DB "unable to connect to nam"
DB "ed pipe, rc=%d",0aH,0H
@STAT17	DB "connected to pipe handle"
DB " %x",0aH,0H
@STAT18	DB "rq",0H
@STAT19	DB "unable to open pipe, rc="
DB "%d",0aH,0H
@STAT1a	DB "opened handle %x for pip"
DB "e",0aH,0H
	ALIGN 04H
@STAT1b	DB "rc from readqueue was %d"
DB 0aH,0H
@STAT1c	DB "g?",0H
	ALIGN 04H
@STAT1d	DB "global data is [%s]",0aH,0H
@STAT1e	DB "i?",0H
@STAT1f	DB "instance data is [%s]",0aH,0H
@STAT20	DB "g=",0H
@STAT21	DB "i=",0H
	DD	_exeentry
DATA32	ENDS
BSS32	SEGMENT
	ALIGN 04H
COMM	ppib:DWORD
	ALIGN 04H
COMM	ptib:DWORD
BSS32	ENDS
CONST32	SEGMENT
CONST32	ENDS
CODE32	SEGMENT

;***** 28 void _System spare(int parm)
	ALIGN 010H

	PUBLIC spare
spare	PROC
	SUB	ESP,04H
	PUSH	EBX
	PUSH	ESI

;***** 32   DosAllocThreadLocalMemory(1+parm,&tlm); 
	LEA	ECX,[ESP+08H];	tlm
	PUSH	ECX
	MOV	EBX,[ESP+014H];	parm
	LEA	ECX,[EBX+01H]
	PUSH	ECX
	MOV	AL,02H
	PUSH	OFFSET CODE32:+020H
	JMP	DosAllocThreadLocalMemory
	ALIGN 010H

;***** 33   printf("thread %d local memory at %p\n",parm,tlm);
	PUSH	DWORD PTR [ESP+010H];	tlm
	PUSH	EBX
	MOV	EAX,OFFSET FLAT: @STAT1
	SUB	ESP,04H
	CALL	_printfieee
	ADD	ESP,014H

;***** 34   tlm[0]=ppib->pib_ulpid;
	MOV	ECX,DWORD PTR  ppib
	MOV	EDX,[ECX]
	MOV	ECX,[ESP+08H];	tlm
	MOV	[ECX],EDX

;***** 35   tlm[1]=ptib->tib_ordinal;
	MOV	EDX,DWORD PTR  ptib
	MOV	EDX,[EDX+014H]
	MOV	[ECX+04H],EDX

;***** 36   tlm[2]=parm;
	MOV	[ECX+08H],EBX

;***** 37   for ( awake=0 ; awake<24*60*60 ; awake++ )
	XOR	ESI,ESI
	ALIGN 010H
FELB35:

;***** 38     {
;***** 39     DosSleep(1000);
	PUSH	03e8H
	MOV	AL,01H
	CALL	DosSleep
	ADD	ESP,04H

;***** 40     if ( 59==(awake%60) ) printf("thread %u sleeping\n",parm);
	MOV	EAX,ESI
	MOV	ECX,03cH
	CDQ	
	IDIV	ECX
	CMP	EDX,03bH
	JNE	FELB36
	PUSH	EBX
	MOV	EAX,OFFSET FLAT: @STAT2
	SUB	ESP,04H
	CALL	_printfieee
	ADD	ESP,08H
FELB36:

;***** 41     }
	INC	ESI
	CMP	ESI,015180H
	JL	FELB35

;***** 42   return;
	POP	ESI
	POP	EBX
	ADD	ESP,04H
	RET	
spare	ENDP

;***** 45 int main(void)
	ALIGN 010H

	PUBLIC main
main	PROC
	PUSH	EBP
	MOV	EBP,ESP
	PUSH	EBX
	PUSH	ESI
	PUSH	EDI
	SUB	ESP,0170H

;***** 52   HQUEUE hcque=0,hoque=0;
	MOV	DWORD PTR [EBP-01cH],0H;	hcque
	MOV	DWORD PTR [EBP-028H],0H;	hoque

;***** 53   HPIPE  hpipe=0;
	MOV	DWORD PTR [EBP-018H],0H;	hpipe

;***** 54   PID pid;
;***** 55   REQUESTDATA qrequest;
;***** 56   ULONG action,qel_len,pip_len,tid2,tid3;
;***** 57   VOID *pdata;
;***** 58   ULONG *tlm;
;***** 59   char prty,mybuf[255];
;***** 60   setbuf(stdout,NULL);
	XOR	EDX,EDX
	MOV	EAX,DWORD PTR  stdout
	CALL	setbuf

;***** 61   DosGetInfoBlocks(&ptib,&ppib);
	PUSH	OFFSET FLAT: ppib
	PUSH	OFFSET FLAT: ptib
	MOV	AL,02H
	CALL	DosGetInfoBlocks

;***** 62   DosAllocThreadLocalMemory(2,&tlm);
	LEA	ECX,[EBP-030H];	tlm
	PUSH	ECX
	PUSH	02H
	MOV	AL,02H
	CALL	DosAllocThreadLocalMemory

;***** 63   printf("thread 1 local memory at %p\n",tlm);
	PUSH	DWORD PTR [EBP-030H];	tlm
	MOV	EAX,OFFSET FLAT: @STAT3
	SUB	ESP,04H
	CALL	_printfieee

;***** 64   tlm[0]=ppib->pib_ulpid;
	MOV	ECX,DWORD PTR  ppib
	MOV	EDX,[ECX]
	MOV	ECX,[EBP-030H];	tlm
	MOV	[ECX],EDX

;***** 65   tlm[1]=ptib->tib_ordinal;
	MOV	EDX,DWORD PTR  ptib
	MOV	EDX,[EDX+014H]
	MOV	[ECX+04H],EDX

;***** 66   DosCreateThread(&tid2,(PFNTHREAD) spare,2,0,4096);
	PUSH	01000H
	PUSH	0H
	PUSH	02H
	PUSH	OFFSET FLAT: spare
	LEA	ECX,[EBP-04cH];	tid2
	PUSH	ECX
	MOV	AL,05H
	CALL	DosCreateThread

;***** 67   DosSleep(500);
	PUSH	01f4H
	MOV	AL,01H
	CALL	DosSleep

;***** 68   DosCreateThread(&tid3,(PFNTHREAD) spare,3,0,4096);
	PUSH	01000H
	PUSH	0H
	PUSH	03H
	PUSH	OFFSET FLAT: spare
	LEA	ECX,[EBP-050H];	tid3
	PUSH	ECX
	MOV	AL,05H
	PUSH	OFFSET CODE32:+0170H
	JMP	DosCreateThread
	ALIGN 010H

;***** 69   DosSleep(500);
	PUSH	01f4H
	MOV	AL,01H
	CALL	DosSleep
	PUSH	OFFSET CODE32:+0190H

;***** 70   g=gbl();
	JMP	gbl
	ALIGN 010H
	MOV	[EBP-034H],EAX;	g

;***** 71   printf("dll global data is located at %p\n",g);
	PUSH	EAX
	MOV	EAX,OFFSET FLAT: @STAT4
	SUB	ESP,04H
	CALL	_printfieee
	PUSH	OFFSET CODE32:+01b0H

;***** 72   i=ins();
	JMP	ins
	ALIGN 010H
	MOV	EBX,EAX
	MOV	[EBP-038H],EBX;	i

;***** 73   printf("dll instance data is located at %p\n",i);
	PUSH	EBX
	MOV	EAX,OFFSET FLAT: @STAT5
	SUB	ESP,04H
	CALL	_printfieee

;***** 74   i->l=ppib->pib_ulpid;  /* set instance data */
	MOV	ECX,DWORD PTR  ppib
	MOV	ECX,[ECX]
	MOV	[EBX],ECX

;***** 75   rc=DosCreateQueue(&hcque,QUE_FIFO,(char *) &qname);
	PUSH	OFFSET FLAT: qname
	PUSH	0H
	LEA	ECX,[EBP-01cH];	hcque
	PUSH	ECX
	MOV	AL,03H
	CALL	DosCreateQueue
	ADD	ESP,064H
	MOV	[EBP-020H],EAX;	rc

;***** 76   if ( 0!=rc && 332!=rc) return printf("rc from create queue was %d\n",rc); 
	OR	EAX,EAX
	JE	FELB39
	CMP	EAX,014cH
	JE	FELB39
	PUSH	EAX
	MOV	EAX,OFFSET FLAT: @STAT6
	SUB	ESP,04H
	PUSH	OFFSET CODE32:+0210H
	JMP	_printfieee
	ALIGN 010H
	ADD	ESP,0178H
	POP	EDI
	POP	ESI
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET	
FELB39:

;***** 77   if ( 0==rc )
	CMP	DWORD PTR [EBP-020H],0H;	rc
	JNE	FELB41

;***** 78     {
;***** 79     printf("create queue handle is %x, open queue handle is %x\n",hcque,hoque);
	PUSH	DWORD PTR [EBP-028H];	hoque
	PUSH	DWORD PTR [EBP-01cH];	hcque
	MOV	EAX,OFFSET FLAT: @STAT7
	SUB	ESP,04H
	CALL	_printfieee

;***** 80     printf("rq will read from the queue\n");
	MOV	EAX,OFFSET FLAT: @STAT8
	CALL	_printfieee
	ADD	ESP,0cH

;***** 81     } 
	JMP	FELB42
	ALIGN 010H
FELB41:

;***** 82   else
;***** 83     {
;***** 84     printf("queue already exists\n"); 
	MOV	EAX,OFFSET FLAT: @STAT9
	PUSH	OFFSET CODE32:+0260H
	JMP	_printfieee
	ALIGN 010H

;***** 85     rc=DosOpenQueue(&pid,&hoque,(char *) &qname);
	PUSH	OFFSET FLAT: qname
	LEA	EBX,[EBP-028H];	hoque
	PUSH	EBX
	LEA	EBX,[EBP-03cH];	pid
	PUSH	EBX
	MOV	AL,03H
	CALL	DosOpenQueue
	ADD	ESP,0cH
	MOV	[EBP-020H],EAX;	rc

;***** 86     if ( rc ) return printf("rc from open queue was %d\n",rc); 
	OR	EAX,EAX
	JE	FELB43
	PUSH	EAX
	MOV	EAX,OFFSET FLAT: @STATa
	SUB	ESP,04H
	CALL	_printfieee
	ADD	ESP,0178H
	POP	EDI
	POP	ESI
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET	
FELB43:

;***** 87     rc=DosCreateNPipe((char*) &pname,&hpipe,NP_ACCESS_DUPLEX,
	PUSH	01b7740H
	PUSH	0200H
	PUSH	0200H
	PUSH	0501H
	PUSH	02H
	LEA	ECX,[EBP-018H];	hpipe
	PUSH	ECX
	PUSH	OFFSET FLAT: pname
	MOV	AL,07H
	CALL	DosCreateNPipe
	ADD	ESP,01cH
	MOV	[EBP-020H],EAX;	rc

;***** 88                       NP_WAIT+NP_TYPE_MESSAGE+NP_READMODE_MESSAGE+1,
;***** 89                       512,512,30*60*1000);
;***** 90     if ( rc ) return printf("unable to create named pipe, rc=%d\n",rc);
	OR	EAX,EAX
	JE	FELB44
	PUSH	EAX
	MOV	EAX,OFFSET FLAT: @STATb
	SUB	ESP,04H
	PUSH	OFFSET CODE32:+02e0H
	JMP	_printfieee
	ALIGN 010H
	ADD	ESP,0178H
	POP	EDI
	POP	ESI
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET	
FELB44:

;***** 91     printf("pipe created, handle=%x\n");
	MOV	EAX,OFFSET FLAT: @STATc
	PUSH	OFFSET CODE32:+0300H
	JMP	_printfieee
	ALIGN 010H

;***** 92     rc=DosCreateEventSem((char *) &sname,&hev,0,0);
	PUSH	0H
	PUSH	0H
	LEA	EBX,[EBP-024H];	hev
	PUSH	EBX
	PUSH	OFFSET FLAT: sname
	MOV	AL,04H
	CALL	DosCreateEventSem
	ADD	ESP,010H
	MOV	[EBP-020H],EAX;	rc

;***** 93     if ( rc ) return printf("unable to create event sem for pipe, rc=%d\n",rc);
	OR	EAX,EAX
	JE	FELB45
	PUSH	EAX
	MOV	EAX,OFFSET FLAT: @STATd
	SUB	ESP,04H
	CALL	_printfieee
	ADD	ESP,0178H
	POP	EDI
	POP	ESI
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET	
FELB45:

;***** 94     printf("pipe sem created\n");
	MOV	EAX,OFFSET FLAT: @STATe
	PUSH	OFFSET CODE32:+0350H
	JMP	_printfieee
	ALIGN 010H

;***** 95     rc=DosSetNPipeSem(hpipe,(HSEM) hev,1);
	PUSH	01H
	MOV	EBX,[EBP-024H];	hev
	PUSH	EBX
	PUSH	DWORD PTR [EBP-018H];	hpipe
	MOV	AL,03H
	CALL	DosSetNPipeSem
	ADD	ESP,0cH
	MOV	[EBP-020H],EAX;	rc

;***** 96     if ( rc ) return printf("unable to set pipe sem, rc=%d\n",rc);
	OR	EAX,EAX
	JE	FELB46
	PUSH	EAX
	MOV	EAX,OFFSET FLAT: @STATf
	SUB	ESP,04H
	PUSH	OFFSET CODE32:+0380H
	JMP	_printfieee
	ALIGN 010H
	ADD	ESP,0178H
	POP	EDI
	POP	ESI
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET	
FELB46:

;***** 97     printf("pipe sem set\n");
	MOV	EAX,OFFSET FLAT: @STAT10
	PUSH	OFFSET CODE32:+03a0H
	JMP	_printfieee
	ALIGN 010H

;***** 98     printf("rp will read from the pipe\n");
	MOV	EAX,OFFSET FLAT: @STAT11
	PUSH	OFFSET CODE32:+03b0H
	JMP	_printfieee
	ALIGN 010H

;***** 99     }
FELB42:

;***** 100   printf("g? and i? will print the global or instance data\n");
	MOV	EAX,OFFSET FLAT: @STAT12
	PUSH	OFFSET CODE32:+03c0H
	JMP	_printfieee
	ALIGN 010H

;***** 101   printf("g= and i= will copy into global or instance data\n");
	MOV	EAX,OFFSET FLAT: @STAT13
	PUSH	OFFSET CODE32:+03d0H
	JMP	_printfieee
	ALIGN 010H

;***** 102   printf("use q, Q, or break to end program\n");
	MOV	EAX,OFFSET FLAT: @STAT14
	PUSH	OFFSET CODE32:+03e0H
	JMP	_printfieee
	ALIGN 010H

;***** 103   while ( fgets(mybuf,sizeof(mybuf),stdin) )
	MOV	ESI,DWORD PTR  stdin
	MOV	ECX,ESI
	MOV	EDX,0ffH
	LEA	EAX,[EBP-016cH];	mybuf
	PUSH	OFFSET CODE32:+0400H
	JMP	fgets
	ALIGN 010H
	OR	EAX,EAX
	JE	FELB47
	MOV	EDI,[EBP-034H];	g
	ADD	EDI,04H
	MOV	[EBP-058H],EDI;	@CBE66
	MOV	EBX,[EBP-038H];	i
	ADD	EBX,04H
	MOV	[EBP-05cH],EBX;	@CBE67
	MOV	ECX,[EBP-060H];	ix
	ALIGN 010H
FELB48:

;***** 104     {
;***** 105     if ( 'q'==(mybuf[0]|' ') ) break;
	XOR	EAX,EAX
	MOV	AL,[EBP-016cH];	mybuf
	OR	AL,020H
	CMP	EAX,071H
	JE	BLBL70
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 106     if ( !strnicmp(mybuf,"rp",2) ) 
	MOV	ECX,02H
	MOV	EDX,OFFSET FLAT: @STAT15
	LEA	EAX,[EBP-016cH];	mybuf
	CALL	strnicmp
	TEST	EAX,0540000H
	MOV	ECX,[EBP-0170H];	@CBE71
	OR	EAX,EAX
	JNE	FELB51
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 107       {
;***** 108       rc=DosConnectNPipe(hpipe);
	PUSH	DWORD PTR [EBP-018H];	hpipe
	MOV	AL,01H
	CALL	DosConnectNPipe
	MOV	ECX,[EBP-0170H];	@CBE71
	ADD	ESP,04H
	MOV	[EBP-020H],EAX;	rc

;***** 109       if ( rc ) return printf("unable to connect to named pipe, rc=%d\n",rc);
	OR	EAX,EAX
	JE	FELB52
	MOV	DWORD PTR  stdin,ESI
	PUSH	EAX
	MOV	EAX,OFFSET FLAT: @STAT16
	SUB	ESP,04H
	PUSH	OFFSET CODE32:+04a0H
	JMP	_printfieee
	ALIGN 010H
	ADD	ESP,0178H
	POP	EDI
	POP	ESI
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET	
FELB52:
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 110       printf("connected to pipe handle %x\n",hpipe);
	PUSH	DWORD PTR [EBP-018H];	hpipe
	MOV	EAX,OFFSET FLAT: @STAT17
	SUB	ESP,04H
	CALL	_printfieee

;***** 111       DosRead(hpipe,&mybuf,sizeof(mybuf),&pip_len);
	LEA	ECX,[EBP-054H];	pip_len
	PUSH	ECX
	PUSH	0ffH
	LEA	ECX,[EBP-016cH];	mybuf
	PUSH	ECX
	PUSH	DWORD PTR [EBP-018H];	hpipe
	MOV	AL,04H
	CALL	DosRead
	MOV	ECX,[EBP-0170H];	@CBE71
	ADD	ESP,018H

;***** 112       }
FELB51:
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 113     if ( !strnicmp(mybuf,"rq",2) )
	MOV	ECX,02H
	MOV	EDX,OFFSET FLAT: @STAT18
	LEA	EAX,[EBP-016cH];	mybuf
	CALL	strnicmp
	TEST	EAX,0540000H
	MOV	ECX,[EBP-0170H];	@CBE71
	OR	EAX,EAX
	JNE	FELB53
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 114       {
;***** 115       rc=DosOpen((char *) &pname,&hfile,&action,0,0,FILE_OPEN,
	PUSH	0H
	PUSH	02012H
	PUSH	01H
	PUSH	0H
	PUSH	0H
	LEA	EDX,[EBP-040H];	action
	PUSH	EDX
	LEA	EDX,[EBP-02cH];	hfile
	PUSH	EDX
	PUSH	OFFSET FLAT: pname
	MOV	AL,08H
	CALL	DosOpen
	MOV	ECX,[EBP-0170H];	@CBE71
	ADD	ESP,020H
	MOV	[EBP-020H],EAX;	rc

;***** 116                 OPEN_ACCESS_READWRITE + OPEN_SHARE_DENYREADWRITE +
;***** 117                                 OPEN_FLAGS_FAIL_ON_ERROR,NULL);
;***** 118       if ( rc ) return printf("unable to open pipe, rc=%d\n",rc);
	OR	EAX,EAX
	JE	FELB54
	MOV	DWORD PTR  stdin,ESI
	PUSH	EAX
	MOV	EAX,OFFSET FLAT: @STAT19
	SUB	ESP,04H
	PUSH	OFFSET CODE32:+0570H
	JMP	_printfieee
	ALIGN 010H
	ADD	ESP,0178H
	POP	EDI
	POP	ESI
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET	
FELB54:
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 119       printf("opened handle %x for pipe\n",hfile);
	PUSH	DWORD PTR [EBP-02cH];	hfile
	MOV	EAX,OFFSET FLAT: @STAT1a
	SUB	ESP,04H
	CALL	_printfieee

;***** 120       rc=DosReadQueue(hcque,&qrequest,&qel_len,&pdata,0,DCWW_WAIT,&prty,0);
	PUSH	0H
	LEA	ECX,[EBP-061H];	prty
	PUSH	ECX
	PUSH	0H
	PUSH	0H
	LEA	ECX,[EBP-048H];	pdata
	PUSH	ECX
	LEA	ECX,[EBP-044H];	qel_len
	PUSH	ECX
	LEA	ECX,[EBP-014H];	qrequest
	PUSH	ECX
	PUSH	DWORD PTR [EBP-01cH];	hcque
	MOV	AL,08H
	CALL	DosReadQueue
	MOV	ECX,[EBP-0170H];	@CBE71
	ADD	ESP,028H
	MOV	[EBP-020H],EAX;	rc

;***** 121       if ( rc ) printf("rc from readqueue was %d\n",rc);
	OR	EAX,EAX
	JE	FELB53
	MOV	[EBP-0170H],ECX;	@CBE71
	PUSH	EAX
	MOV	EAX,OFFSET FLAT: @STAT1b
	SUB	ESP,04H
	PUSH	OFFSET CODE32:+05e0H
	JMP	_printfieee
	ALIGN 010H
	MOV	ECX,[EBP-0170H];	@CBE71
	ADD	ESP,08H

;***** 122       }
FELB53:
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 123     if ( !strnicmp(mybuf,"g?",2) ) printf("global data is [%s]\n",g->buf);
	MOV	ECX,02H
	MOV	EDX,OFFSET FLAT: @STAT1c
	LEA	EAX,[EBP-016cH];	mybuf
	CALL	strnicmp
	TEST	EAX,0540000H
	MOV	ECX,[EBP-0170H];	@CBE71
	OR	EAX,EAX
	JNE	FELB56
	MOV	[EBP-0170H],ECX;	@CBE71
	PUSH	DWORD PTR [EBP-058H];	@CBE66
	MOV	EAX,OFFSET FLAT: @STAT1d
	SUB	ESP,04H
	PUSH	OFFSET CODE32:+0630H
	JMP	_printfieee
	ALIGN 010H
	MOV	ECX,[EBP-0170H];	@CBE71
	ADD	ESP,08H
FELB56:
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 124     if ( !strnicmp(mybuf,"i?",2) ) printf("instance data is [%s]\n",i->buf);
	MOV	ECX,02H
	MOV	EDX,OFFSET FLAT: @STAT1e
	LEA	EAX,[EBP-016cH];	mybuf
	CALL	strnicmp
	TEST	EAX,0540000H
	MOV	ECX,[EBP-0170H];	@CBE71
	OR	EAX,EAX
	JNE	FELB57
	MOV	[EBP-0170H],ECX;	@CBE71
	PUSH	DWORD PTR [EBP-05cH];	@CBE67
	MOV	EAX,OFFSET FLAT: @STAT1f
	SUB	ESP,04H
	PUSH	OFFSET CODE32:+0680H
	JMP	_printfieee
	ALIGN 010H
	MOV	ECX,[EBP-0170H];	@CBE71
	ADD	ESP,08H
FELB57:

;***** 125     for ( ix=0 ; mybuf[ix] ; ix++ ) 
	MOV	ECX,0H
	CMP	BYTE PTR [EBP-016cH],0H;	mybuf
	JE	FELB58
	ALIGN 010H
FELB59:

;***** 126       if ( mybuf[ix]<' ' ) break;
	CMP	BYTE PTR [EBP+ECX-016cH],020H
	JB	FELB58
	INC	ECX
	CMP	BYTE PTR [EBP+ECX-016cH],0H
	JNE	FELB59
FELB58:

;***** 127     mybuf[ix]='\0';
	MOV	BYTE PTR [EBP+ECX-016cH],0H
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 128     if ( !strnicmp(mybuf,"g=",2) ) strcpy(g->buf,mybuf+2);
	MOV	ECX,02H
	MOV	EDX,OFFSET FLAT: @STAT20
	LEA	EAX,[EBP-016cH];	mybuf
	PUSH	OFFSET CODE32:+06e0H
	JMP	strnicmp
	ALIGN 010H
	TEST	EAX,0540000H
	MOV	ECX,[EBP-0170H];	@CBE71
	OR	EAX,EAX
	JNE	FELB62
	MOV	[EBP-0170H],ECX;	@CBE71
	LEA	EDX,[EBP-016aH];	mybuf
	MOV	EAX,EDI
	CALL	strcpy
	TEST	EAX,0500000H
	MOV	ECX,[EBP-0170H];	@CBE71
FELB62:
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 129     if ( !strnicmp(mybuf,"i=",2) ) strcpy(i->buf,mybuf+2);
	MOV	ECX,02H
	MOV	EDX,OFFSET FLAT: @STAT21
	LEA	EAX,[EBP-016cH];	mybuf
	PUSH	OFFSET CODE32:+0730H
	JMP	strnicmp
	ALIGN 010H
	TEST	EAX,0540000H
	MOV	ECX,[EBP-0170H];	@CBE71
	OR	EAX,EAX
	JNE	FELB63
	MOV	[EBP-0170H],ECX;	@CBE71
	LEA	EDX,[EBP-016aH];	mybuf
	MOV	EAX,EBX
	CALL	strcpy
	TEST	EAX,0500000H
	MOV	ECX,[EBP-0170H];	@CBE71
FELB63:
	MOV	[EBP-0170H],ECX;	@CBE71

;***** 130     }
	MOV	ECX,ESI
	MOV	EDX,0ffH
	LEA	EAX,[EBP-016cH];	mybuf
	PUSH	OFFSET CODE32:+0780H
	JMP	fgets
	ALIGN 010H
	MOV	ECX,[EBP-0170H];	@CBE71
	OR	EAX,EAX
	JNE	FELB48
BLBL70:
	MOV	DWORD PTR  stdin,ESI
FELB47:

;***** 131   DosClose(hfile);
	PUSH	DWORD PTR [EBP-02cH];	hfile
	MOV	AL,01H
	CALL	DosClose

;***** 132   DosClose(hev);
	PUSH	DWORD PTR [EBP-024H];	hev
	MOV	AL,01H
	PUSH	OFFSET CODE32:+07b0H
	JMP	DosClose
	ALIGN 010H

;***** 133   DosClose(hpipe);
	PUSH	DWORD PTR [EBP-018H];	hpipe
	MOV	AL,01H
	PUSH	OFFSET CODE32:+07c0H
	JMP	DosClose
	ALIGN 010H

;***** 134   DosCloseQueue(hoque);
	PUSH	DWORD PTR [EBP-028H];	hoque
	MOV	AL,01H
	PUSH	OFFSET CODE32:+07d0H
	JMP	DosCloseQueue
	ALIGN 010H
	ADD	ESP,010H

;***** 135   if ( hcque!=hoque && 0!=hcque ) DosCloseQueue(hcque);
	MOV	ECX,[EBP-01cH];	hcque
	CMP	ECX,[EBP-028H];	hoque
	JE	FELB64
	OR	ECX,ECX
	JE	FELB64
	PUSH	ECX
	MOV	AL,01H
	PUSH	OFFSET CODE32:+07f0H
	JMP	DosCloseQueue
	ALIGN 010H
	ADD	ESP,04H
FELB64:

;***** 136   DosKillThread(tid2);
	PUSH	DWORD PTR [EBP-04cH];	tid2
	MOV	AL,01H
	CALL	DosKillThread

;***** 137   DosKillThread(tid3);
	PUSH	DWORD PTR [EBP-050H];	tid3
	MOV	AL,01H
	PUSH	OFFSET CODE32:+0810H
	JMP	DosKillThread
	ALIGN 010H
	ADD	ESP,08H

;***** 138   return 0;
	XOR	EAX,EAX
	ADD	ESP,0170H
	POP	EDI
	POP	ESI
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET	
main	ENDP
CODE32	ENDS
END
