
#define INCL_DOSFILEMGR
#include <OS2.h>
#include <stdio.h>

int main(int argc,char *argv[])
  {
  APIRET rc;
  HFILE hFile;
  ULONG action;
  FILELOCK LockArea={0,256},UnlockArea={0,0};
  char buf[64];
  rc=DosOpen("LARK.MAP",&hFile,&action,0L,FILE_ARCHIVED,FILE_OPEN,
              OPEN_ACCESS_READWRITE + OPEN_SHARE_DENYNONE,0L);                           /* No extended attributes */
  if ( rc ) return printf("DosOpen return code=%u\n", rc);
  if ( 3==argc )  
    {
    if ( 0==sscanf(argv[1],"%x",&LockArea.lOffset)
    ||   0==sscanf(argv[2],"%x",&LockArea.lRange) )
      {
      LockArea.lOffset=0;
      LockArea.lRange=256;
      }
    else printf("range locked is offset 0x%x for 0x%x bytes\n",
              LockArea.lOffset,LockArea.lRange);
    }
  while ( DosSetFileLocks(hFile,&UnlockArea,&LockArea,60000,0) ) ;
  printf("please start another copy of %s\n",argv[argc-argc]);
  for ( ;; ) fgets(buf,sizeof(buf),stdin);
  DosClose(hFile);
  return 0;
  }
