
#define INCL_DOSFILEMGR
#include <OS2.h>
#include <stdio.h>
#include <string.h>

int main(int argc,char *argv[])
  {
  APIRET rc;
  HFILE hFile;
  ULONG action,lrecl=16;
  FILELOCK LockArea={0,16},UnlockArea={0,0};
  char buf[64];
  rc=DosOpen("VIN",&hFile,&action,0L,FILE_ARCHIVED,FILE_OPEN,
              OPEN_ACCESS_READWRITE + OPEN_SHARE_DENYNONE,0L);                           /* No extended attributes */
  if ( rc ) return printf("DosOpen return code=%u\n", rc);
  if ( 3==argc )  
    {
    if ( 0==sscanf(argv[1],"%x",&LockArea.lOffset)
    ||   0==sscanf(argv[2],"%x",&LockArea.lRange) )
      {
      LockArea.lOffset=0;
      LockArea.lRange=256;
      }
    }
  else 
    {
    for ( ;; )
      {
      rc=DosRead(hFile,buf,lrecl,&action);
      if ( 33==rc ) break;  /* cannot read through a lock! */
      if ( rc ) return printf("cannot get VIN, rc %d\n",rc);
      if ( action!=LockArea.lRange ) return printf("not enough VIN\n");
      if ( !strnicmp(buf,"champagne",9) ) break;
      LockArea.lOffset+=LockArea.lRange;
      }
    }
  while ( DosSetFileLocks(hFile,&UnlockArea,&LockArea,60*60*1000,0) ) ;
  printf("'pain' needs 'fromage'.\nplease start it.\n");
  for ( ;; ) fgets(buf,sizeof(buf),stdin);
  DosClose(hFile);
  return 0;
  }
