
/* this is canary.c */

#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_NOPMAPI
#include <os2.h>
#include <stdio.h>

HSEM Synch=0L,SysSem;
DOSFSRSEM FSRamSem;

int thread2(void)
  {
  USHORT rc;
  FSRamSem.cb=sizeof(FSRamSem);
  FSRamSem.pid=0L;
  FSRamSem.tid=0L;
  FSRamSem.cUsage=0;
  FSRamSem.client=0;
  FSRamSem.sem=0L;
  rc=DosFSRamSemRequest(&FSRamSem,-1L);
  if ( rc )  return printf( "Unexpected DosFSSemRequest rc %d\n",rc);
  rc=DosSemClear(&Synch);
  if ( rc )  return printf( "Unexpected DosSemClear rc %d\n",rc);
  rc=DosSemRequest(SysSem,-1L);
  if ( rc ) return printf("TID 2: Unexpected DosSemRequest rc %d\n",rc);
  return 0;
  }

int main(int argc)
  {
  USHORT pStk,rc,tid2;
  rc=DosCreateSem(0,&SysSem,"\\SEM\\HANG_CANARY");
  if ( rc ) return printf("Unexpected DosCreateSem rc %d\n",rc);
  rc=DosSemRequest(SysSem,-1L);
  if ( rc ) return printf("TID 1: Unexpected DosSemRequest rc %d\n",rc);
  rc=DosAllocSeg(1024,&pStk,0);
  if ( rc ) return printf("Unexpected DosAllocSeg rc %d\n",rc);
  rc=DosSemSet(&Synch);
  if ( rc ) return printf("Unexpected DosSemSet rc %d\n",rc);
  rc=DosCreateThread(thread2,&tid2,MAKEP(pStk,1024));
  if ( rc ) return printf("Unexpected DosCreateThread rc %d\n",rc);
  rc=DosSemWait(&Synch,-1L);
  if ( rc )  return printf( "Unexpected DosSemWait rc %d\n",rc);
  rc=DosFSRamSemRequest(&FSRamSem,-1L);
  if ( rc )  return printf( "Unexpected DosFSSemRequest rc %d\n",rc);
  return argc-argc;
  }
