
/* this is demo.c */

#include <stdio.h>
#define INBUFSIZE 80
#define NPRIME 5000
unsigned short prime[NPRIME];

int gen(void)
  {
  unsigned short ix,l=2,ll=25,npr=3,q,t,tp=2,tt;
  prime[0]=2;
  prime[1]=3;
  prime[2]=5;
  for ( t=7 ; t<65530 ; t+=tp )
    {
    tp=6-tp;
    if ( ll<=t ) 
      {
      l++;
      ll=prime[l]*prime[l];
      }
    for ( ix=2 ; ix<l ; ix++ ) 
      {
      q=t/prime[ix];
      tt=q*prime[ix];
      if ( t==tt ) break;
      }
    if ( l==ix ) prime[npr++]=t;
    }
  return npr;
  }

int main(int argc, char *argv[])
  { 
  static char inbuf[INBUFSIZE];
  int ix,last,nf;
  unsigned short fact[32],input=0,is,q;
  last=gen();
  printf("there are %u primes less than 65536\n",last);
  if ( 1<argc )
    if ( 0==sscanf(argv[1],"%u",&input) ) argc=1;
  while ( 2>argc )
    {
    printf("Enter number to factor: ");  
    fgets(inbuf,INBUFSIZE,stdin);
    if ( 0==sscanf(inbuf,"%u",&input) ) 
      printf("Unable to convert number. Please try again\n");
    else break;
    }
  for ( ix=nf=0,is=input ; ix<last ; ix++ )
    {
    q=input/prime[ix];
    while ( q*prime[ix]==input )
      {
      fact[nf++]=prime[ix];
      input/=prime[ix];
      q=input/prime[ix];
      }
    }
  if ( nf<2 ) return printf("%u is prime\n",is);
  printf("%u=%u",is,fact[0]);
  for ( ix=1 ; ix<nf ; ix++ )
    printf("*%u",fact[ix]);
  return printf("\n");
  }
