
/* this is demo.c */

#define INCL_DOSMEMMGR
#define INCL_NOPMAPI
#include <os2.h>
#include <stdio.h>

int gen(int *prime)
  {
  int ix,l=2,ll=25,npr=3,q,t,tp=2,tt;
  prime[0]=2;
  prime[1]=3;
  prime[2]=5;
  for ( t=7 ; t<65530 ; t+=tp )
    {
    tp=6-tp;
    if ( ll<=t ) 
      {
      l++;
      ll=prime[l]*prime[l];
      }
    for ( ix=2 ; ix<l ; ix++ ) 
      {
      q=t/prime[ix];
      tt=q*prime[ix];
      if ( t==tt ) break;
      }
    if ( l==ix ) prime[npr++]=t;
    }
  return npr;
  }

int main(int argc, char *argv[])
  { 
  int ix,last,*p;
  void *mem;
  unsigned rc;
  rc=DosAllocMem(&mem,16384,PAG_READ+PAG_WRITE+PAG_COMMIT);
  if ( rc ) return printf("non-zero return code from DosAllocMem=%d\n",rc);
  last=gen(p=mem);
  printf("there are %u primes less than 65536\n",last);
  for ( ix=0 ; ix<last ; ix++ )
    {
    printf("%6u ",p[ix]);
    if ( 9==(ix%10) ) printf("\n"); 
    }
  return 0;
  }
