
/* this is awkd.c, a simple dll that calls functions indirectly. */

#define INCL_DOSMODULEMGR
#define INCL_DOSPROCESSES
#define INCL_NOPMAPI
#include <os2.h>
#pragma data_seg(GLOBAL)
HMODULE hmod;
int instancecount=0;
char global[]="This is the shared (global) data for awk.dll";
#pragma data_seg()
char instance[]="This is private (instance) data for awk.dll";

int wonst(PFN fn)
  {
  fn();
  return 1;
  }

int tooth(PFN fn)
  {
  if ( fn ) fn=NULL;
  DosFreeModule(hmod);
  return 2;
  }

void initialize_global(HMODULE modh)
  {
  hmod=modh;
  return;
  }

void terminate_global(void)
  {
  hmod=0;
  return;
  }

void initialize_instance(void)
  {
  int ix;
  ++instancecount;
  for ( ix=0 ; ix<instancecount ; ix++ )
    {
    DosBeep(1760,200);
    DosSleep(200);
    }
  return;
  }

void terminate_instance(void)
  {
  DosBeep(880,100);
  DosSleep(100);
  instancecount--;
  return;
  }

ULONG _System _DLL_InitTerm(HMODULE hmod,int it)
  {
  switch (it)
    {
  case 0: /* initialization */
    if ( 0==instancecount ) initialize_global(hmod);
    initialize_instance();
    break;
  case 1: /* termination */
    terminate_instance();
    if ( 0==instancecount ) terminate_global();
    }
  return 1;
  }
