
/* this is a simple program that demos how to load/unload a dll. */

#define INCL_DOSMODULEMGR
#define INCL_DOSPROCESSES
#define INCL_NOPMAPI
#include <os2.h>
#include <stdio.h>
#define NPROCS 8

int nprocs;
PFN procs[NPROCS];   
HMODULE hmod;
char errbuf[256];

int dummy(void)
  {
  printf("routine in .exe successfully called from .dll\n");
  return 0;
  }

int dllfree(void)
  {
  int rc;
  rc=DosFreeModule(hmod);
  if ( rc ) return printf("DosFreeModule rc=%d\n",rc);
  printf("hMTE %x: free successful\n",hmod);
  return 0;
  }

int main(int argc)
  {
  int ix,rc;
  rc=DosLoadModule(errbuf,sizeof(errbuf),"awk",&hmod);
  if ( rc ) return printf("DosLoadModule rc=%d, %s\n",rc,errbuf);
  printf("hMTE for AWK.DLL is %x\n",hmod);
  for ( nprocs=1 ; nprocs<NPROCS ; nprocs++ )
    {
    rc=DosQueryProcAddr(hmod,nprocs,NULL,&procs[nprocs]);
    if ( rc ) break; 
    printf("AWK.DLL ordinal %d at %p\n",nprocs,procs[nprocs]);
    }
  if ( 182!=rc ) printf("GetProcAddr for ordinal %d rc=%d\n",nprocs,rc);
  procs[1](dummy);
  if ( 1<argc ) procs[1](dllfree);
  else          procs[2](dummy);
  rc=dllfree();
  return rc;
  }
