
/* this is kiwi, a simple program that feeds BUGBUG */

#define INCL_DOSDATETIME
#define INCL_DOSDEVICES
#define INCL_DOSERRORS 
#define INCL_DOSEXCEPTIONS
#define INCL_DOSFILEMGR
#define INCL_DOSMISC
#define INCL_DOSMODULEMGR
#define INCL_DOSNMPIPES  
#define INCL_DOSPROCESS
#define INCL_DOSQUEUES 
#define INCL_DOSSEMAPHORES
#define INCL_DOSSESMGR
#define INCL_NOPMAPI
#include <os2.h>
#include <stdio.h>
#include <string.h>
int numbugs;
char buf[64];
#define NUMBUGS 60
 
struct { char name[12]; char msg[16]; } bug[NUMBUGS]={
  " aardvark","bugdd=mouse$  "," anteater","ifs=2"," ape","",
  " bear","ifs=1"," buffalo","hang3"," camel",""," cat","ifs=0",
  " cheetah",""," chipmonk",""," cow",""," deer","hang1"," dog","",
  " elephant",""," elk","ifs=6"," ferret",""," fox","trapd",
  " giraffe",""," hippo","ifs=7"," horse","hang5"," instructor","ipe",
  " jaguar",""," kangaroo",""," koala","trap8"," leopard","bugdd=con     ",
  " lion","hang4"," marmot",""," meercat","ifs=4"," monkey","",
  " moose","trape"," mouse",""," mule",""," panda","trap2",
  " panther","bugdd=prn     "," pig","hang7"," puma","ifs=5"," rhino","",
  " seal","hang2"," sheep",""," sloth","bugdd=prn     "," squirrel","hang6",
  " tiger",""," walrus","ifs=3"," weasel",""," wolf","bugdd=ibmkbd$ ",
  " zebra","" "",""};

int init()
  { /* there's room for 21. count them yourself! */
  #define NUMAPIS 25
  int ix,iy,num_apis=0;
  int de,dqm,dqsi,dsd,dsfl;
  union
    {
    char           *pc;
    unsigned short *pu; 
    unsigned short us[2];
    } hackers;
  void *rtns[NUMAPIS];
  USHORT sel[NUMAPIS];
  rtns[num_apis++]=(void*) DosAllocMem;            /* 00 */
  rtns[num_apis++]=(void*) DosBeep;                /* 01 */
  rtns[num_apis++]=(void*) DosDupHandle;           /* 02 */  
  de=num_apis;
  rtns[num_apis++]=(void*) DosExit;                /* 03 */
  rtns[num_apis++]=(void*) DosForceDelete;         /* 04 */
  rtns[num_apis++]=(void*) DosFreeMem;             /* 05 */
  rtns[num_apis++]=(void*) DosGetSharedMem;        /* 06 */
  rtns[num_apis++]=(void*) DosGiveSharedMem;       /* 07 */
  rtns[num_apis++]=(void*) DosLoadModule;          /* 08 */
  rtns[num_apis++]=(void*) DosPhysicalDisk;        /* 09 */
  dqm=num_apis;
  rtns[num_apis++]=(void*) DosQueryMem;            /* 10 */
  dqsi=num_apis;
  rtns[num_apis++]=(void*) DosQuerySysInfo;        /* 11 */
  rtns[num_apis++]=(void*) DosReleaseMutexSem;     /* 12 */
  rtns[num_apis++]=(void*) DosSendSignalException; /* 13 */
  dsfl=num_apis;
  rtns[num_apis++]=(void*) DosSetFileLocks;        /* 14 */
  rtns[num_apis++]=(void*) DosSetPriority;         /* 15 */
  dsd=num_apis;
  rtns[num_apis++]=(void*) DosShutdown;            /* 16 */
  rtns[num_apis++]=(void*) DosSleep;               /* 17 */
  rtns[num_apis++]=(void*) DosStartTimer;          /* 18 */
  rtns[num_apis++]=(void*) DosWaitThread;          /* 19 */
  rtns[num_apis++]=(void*) DosSetExceptionHandler; /* 20 */
  rtns[num_apis  ]=NULL;                           /* 21 */                             
  rtns[num_apis+1]=NULL;                           /* 22 */                             
  rtns[num_apis+2]=NULL;                           /* 23 */                             
  rtns[num_apis+3]=NULL;   /* note this must not be > 24 */                             
  if ( num_apis>=NUMAPIS ) return printf("Too many API's specified\n");

  for ( ix=0 ; ix<NUMAPIS ; ix++ )
    {
    sel[ix]=0;
    if ( NULL==rtns[ix] ) break;
    hackers.pc=rtns[ix];
    for ( iy=0 ; iy<16 ; iy++)
      {
      if ( '\0'==hackers.pc[iy+1] && '\0'==hackers.pc[iy+2] )
        {
        if ( '\x9a'==hackers.pc[iy] 
        &&   '\0'==hackers.pc[iy+3]
        &&   '\0'==hackers.pc[iy+4] )
          {
          hackers.pc+=iy+5;
          sel[ix]=*hackers.pu;
          break;
          }
        if ( '\xb8'==hackers.pc[iy] )
          {
          hackers.pc+=iy+3;
          sel[ix]=*hackers.pu;
          break;
          }
        }
      }
    sel[ix]&=0xfffc;
    }
  for ( ix=numbugs=0 ; numbugs<NUMBUGS ; numbugs++ ) 
    {
    if ( '\0'==bug[numbugs].name[0] ) break; /* that's all folks! */
    if ( bug[numbugs].msg[0] ) continue;     /* that bug is taken */
    if ( ix<num_apis )
      {
      if ( sel[ix] )
        for ( iy=ix+1 ; iy<num_apis ; iy++ )
          if ( sel[ix]==sel[iy] ) sel[iy]=0;
      if (   de==ix ) bug[numbugs].name[0]='+'; /* DosExit         */
      if (  dqm==ix ) bug[numbugs].name[0]='-'; /* DosQueryMem     */
      if ( dqsi==ix ) bug[numbugs].name[0]='&'; /* DosQuerySysInfo */
      if ( dsfl==ix ) bug[numbugs].name[0]='@'; /* DosSetFileLocks */
      if (  dsd==ix ) bug[numbugs].name[0]='*'; /* DosShutdown     */
      sprintf(bug[numbugs].msg,"bugcg=%04x",sel[ix]);
      ix++;
      }
    else sprintf(bug[numbugs].msg,"bugcg=ffff");
    }
  return 0;
  }
       
int bugit(int bugnum)
  {
  FILE *fi,*fo;
  int ix,iy,iz;
  struct cpuregs   
    {
    unsigned long cr0;
    unsigned long cr3;
    unsigned short tr;
    unsigned short gdtlim;
    unsigned long gdtbase;
    unsigned short ldtr;
    unsigned short idtlim;
    unsigned long idtbase;
    } r;
  setbuf(stdout,NULL);
  fi=fopen("#BUGBUG#","rb");
  if ( NULL==fi ) return printf("Cannot open lab device driver\n");
  fo=fopen("#BUGBUG#","w");
  if ( NULL==fo ) 
    {
    fclose(fi); 
    return printf("Cannot open lab device driver\n");
    }
  setbuf(fo,NULL);
  if ( 0>bugnum )
    {
    fprintf(fo,"xregs\n");
    fread(&r,sizeof(struct cpuregs),1,fi);
    printf("cr0=%08x, gdtb=%08x, gdtl=%04x, ldtr=%04x\n",
            r.cr0,r.gdtbase,r.gdtlim,r.ldtr);
    printf("cr3=%08x, idtb=%08x, idtl=%04x,   tr=%04x\n",
            r.cr3,r.idtbase,r.idtlim,r.tr);
    printf("please enter string for dd, or ?: ");
    fgets(buf,31,stdin);
    fprintf(fo,"%s",buf);
    }
  else fprintf(fo,"%s\n",bug[bugnum].msg); 
  fgets(buf,31,fi);
  fclose(fi);
  fclose(fo);
  printf("%s",buf);
  return strncmp(buf,"????",4) ? 0 : 1;
  }

int main(int argc, char *argv[])
  {
  int ix,key=0;
  if ( 1<argc ) if ( !stricmp(argv[1],"fruit") ) key=1;
  setbuf(stdout,NULL);
  if ( init() ) return printf("Storage overlay, attempting to exit\n");
  if ( 1==key )
    {
    printf("\nI can cause %d unique problems.\n",numbugs);
    printf("+Exit  -QueryMem  &QuerySysInfo  @SetFileLocks  *Shutdown\n");
    for ( ix=0 ; ix<numbugs ; ix++ )
      {         /*12345678901234567890123456789012345678901234567890*/
      strcpy(buf,"                                                  ");
      sprintf(buf,"%11s:%s               ",bug[ix].name,bug[ix].msg);
      buf[25]='\0';
      printf( 2==(ix%3) ? "%s\n" : "%s",buf);
      }
    if ( ix%3 ) printf("\n");
    printf("ifs=1-->md   ifs=3-->rd   ifs=4-->findfirst   ifs=6-->close\n");
    printf("ifs=2-->cd   ifs=4-->del  ifs=5-->findnext    ifs=7-->exit\n");
    if ( bugit(-1) ) printf("dd did not install the problem.");
    else             printf("dd installed problem successfully");
    return 0;
    }
  for ( ;; )
    {
    buf[0]='\0';
    printf("\nWhich problem should I install? ");
    fgets(buf,20,stdin);
    if ( '?'==buf[0] )
      {  
      printf("recognized problem names are:\n");
      for ( argc=ix=0 ; ix<numbugs ; ix++ )
        {
        printf("%s   ",bug[ix].name+1);
        argc+=strlen(bug[ix].name)+2;
        if ( argc>50 ) 
          {
          printf("\n");
          argc=0;
          }
        }
      if ( argc ) printf("\n");
      continue;
      }
    for ( ix=0 ; ix<24 ; ix++ )
      if ( ' '>buf[ix] ) break;
    buf[ix]='\0';
    if ( 0==ix ) 
      {
      printf("you elected not to install a problem");
      break;
      }
    for ( ix=0 ; ix<numbugs ; ix++ )
      if ( !strcmp(buf,bug[ix].name+1) ) break;
    if ( ix==numbugs ) 
      {
      printf("%s? what %s? Is one approaching?\n",buf,buf);
      continue;
      }
    if ( bugit(ix) ) printf("%s problem cannot be installed.",bug[ix].name+1);
    else             printf("%s problem installed.",bug[ix].name+1);
    break;
    }
  return 0;
  }
