
#define INCL_DOSPROCESS
#define INCL_NOPMAPI
#include <os2.h>
#include <stdio.h>
#include <string.h>

int main(int argc,char *argv[])
  {
  int ix;
  APIRET rc;
  PIB *pib;
  PID pid;
  TIB *tib;
  RESULTCODES res;
  char args[256],err[256],exec[256];
  DosGetInfoBlocks(&tib,&pib);
  printf("Pid %u, PPid %u is running\n",pib->pib_ulpid,pib->pib_ulppid);
  for ( ix=0 ; ix<sizeof(args) ; ix++ ) args[ix]='\0';
  if ( 2>argc ) 
    { /* execute self with parm */
    strcpy(exec,argv[0]);
    if ( stricmp(exec+strlen(exec)-4,".exe") ) strcat(exec,".exe");
    strcpy(args,argv[0]);
    strcpy(args+strlen(argv[0])+1,"sleep");
    rc=DosExecPgm(err,sizeof(err),EXEC_ASYNCRESULT,args,NULL,&res,exec);
    if ( rc ) return printf("DosExecPgm returns %u\n",rc);
    rc=DosWaitChild(DCWA_PROCESS,DCWW_WAIT,&res,&pid,0);
    if ( rc ) return printf("unexpected rc=%u from DosCWait.\n",rc);
    }
  else while ( 0==DosSleep(60*60*1000) ) printf("still sleeping\n");
  printf("Pid %u terminate code %u, result code %u\n",pid,
          res.codeTerminate,res.codeResult); 
  printf("Pid %u ending\n",pib->pib_ulpid);
  return 0;
  }
