       
/* This is BLUEBIRD.C */
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#include <os2.h>
#include <stdio.h> 

HMTX hMtx[16];
int wait;

void _System thread(unsigned long tid)
  { 
  unsigned rc;
  rc=DosCreateMutexSem(NULL,&hMtx[tid],0,0);
  if ( rc )
    {
    printf("thread %d: %rc from DosCreateMutexSem is %u\n",tid,rc);
    return;
    }
  rc=DosRequestMutexSem(hMtx[tid],(unsigned) -1);
  if ( rc )
    {
    printf("thread %d rc from DosRequestMutexSem is %u\n",tid+1,rc);
    return; 
    }
  printf("thread %d ok\n",tid);
  wait=0;
  rc=DosRequestMutexSem(hMtx[tid-1],(unsigned) -1);
  if ( rc ) 
    {
    printf("thread %d rc from DosRequestMutexSem is %u\n",tid+1,rc);
    return;
    }
  rc=DosCloseMutexSem(hMtx[tid]);
  if ( rc ) 
    {
    printf("thread %d rc from DosClosetMutexSem is %u\n",tid+1,rc);
    return;
    }
  return;
  }

int main(int argc)
  {
  int ix;
  unsigned int rc;
  unsigned long int tid;
  rc=DosCreateMutexSem("\\SEM32\\BLUEBIRD\\MUST_WAIT",&hMtx[1],0,0);
  if ( rc ) return printf("rc from DosCreateMutexSem is %u\n",rc);
  rc=DosRequestMutexSem(hMtx[1],(unsigned) -1);
  if ( rc ) return printf("rc from DosRequestMutexSem[0] is %u\n",rc);
  if ( argc<2 ) argc=2;
  if ( argc>15 ) argc=15;
  for ( ix=1 ; ix<argc ; ix++ )
    {
    wait=1;
    rc=DosCreateThread(&tid,thread,(unsigned) ix+1,0,4096);
    if ( rc ) return printf("rc=%u for create thread %d\n",rc,ix+1);
    while (wait ) DosSleep(250);
    }
  printf("%d threads started.\nthread 1 ok.\n",argc-1); 
  rc=DosRequestMutexSem(hMtx[argc],(unsigned) -1);
  if ( rc ) return printf("rc from DosRequestMutexSem[%d] is %u\n",argc-1,rc);
  rc=DosCloseMutexSem(hMtx[1]);
  if ( rc ) return printf("rc from DosCloseMutexSem is %u\n",rc);
  printf("program exit\n");
  return 0;
  }
